# DSP ![MIT license](https://img.shields.io/github/license/CSpyridakis/DSP?style=plastic) ![Size](https://img.shields.io/github/repo-size/CSpyridakis/DSP.svg?style=plastic)

This repository contains code and report files of Labs implemented for a Digital Signal Processing Course at the Technical University of Crete.
During this course, four Labs were carried out with specific learning objectives for each.

### Learning objectives
#### [Lab 1](./Exercise-1): 
* Fourier Transform
* Discrete Time Convolution
* Nyquist - Shannon Signal Sampling Theorem
* Signal Reconstruction.

#### [Lab 2](./Exercise-2): 
* Z Transform 
* Inverse Z Transform
* BIBO stability in Z plane 
* Difference equation
* Transfer Function in Z plane

#### [Lab 3](./Exercise-3): 
* IIR Filters 
* Butterworth Filter
* Chebyshev Filter

#### [Lab 4](./Exercise-4):
* FIR Filters
* Rectangular Filter and Gibbs phenomenon
* Hamming Filter
* Hanning FIlter

### Documentation
If you want more information about each lab you could read (or just try to read, unfortunately at this point are only in greek language) the following report files:

1. [Lab 1 - Report](./Exercise-1/doc/DSP-LAB-1_REPORT.pdf)
2. [Lab 2 - Report](./Exercise-2/doc/DSP-LAB-2_REPORT.pdf)
3. [Lab 3 - Report](./Exercise-3/doc/DSP-LAB-3_REPORT.pdf)
4. [Lab 4 - Report](./Exercise-4/doc/DSP-LAB-4_REPORT.pdf)

### Code
Moreover, code created for these labs is available here:

1. [Lab 1](./Exercise-1/src)
2. [Lab 2](./Exercise-2/src)
3. [Lab 3](./Exercise-3/src)
3. [Lab 4](./Exercise-4/src)

### Authors
* Spyridakis Christos
* Marinou Ioanna
* Paterakis Isidoros
